
const TronWeb = require('../dist/TronWeb.node.js');

const fullNode = 'https://api.trongrid.io';
const solidityNode = 'https://api.trongrid.io';
const eventServer = 'https://api.trongrid.io';
const privateKey = process.env.SEED

const app = async () => {
    const tronWeb = new TronWeb(
        fullNode,
        solidityNode,
        eventServer,
        privateKey
    );
    const transaction = await tronWeb.transactionBuilder.freezeBalance(50e6, 3, 'ENERGY', 'TB4v1dttX7UZLXiSDNT5QQxmi3PcvuQ8ta')
    const signedTransaction = await tronWeb.trx.sign(transaction, privateKey);

    console.log(JSON.stringify({
        signedTransaction,
        receipt: await tronWeb.trx.sendRawTransaction(signedTransaction)
    }, null, 2))

}
try {
    app()
}catch(err) {
    console.log(err)
}
